Index: src/backend/access/transam/xact.c
===================================================================
RCS file: /home/sriggs/pg/REPOSITORY/pgsql/src/backend/access/transam/xact.c,v
retrieving revision 1.271
diff -c -r1.271 xact.c
*** src/backend/access/transam/xact.c	1 Jan 2009 17:23:36 -0000	1.271
--- src/backend/access/transam/xact.c	11 Jan 2009 11:32:24 -0000
***************
*** 416,422 ****
  	s->transactionId = GetNewTransactionId(isSubXact);
  
  	if (isSubXact)
! 		SubTransSetParent(s->transactionId, s->parent->transactionId);
  
  	/*
  	 * Acquire lock on the transaction XID.  (We assume this cannot block.) We
--- 416,422 ----
  	s->transactionId = GetNewTransactionId(isSubXact);
  
  	if (isSubXact)
! 		SubTransSetParent(s->transactionId, GetTopTransactionIdIfAny());
  
  	/*
  	 * Acquire lock on the transaction XID.  (We assume this cannot block.) We
Index: src/backend/storage/lmgr/lmgr.c
===================================================================
RCS file: /home/sriggs/pg/REPOSITORY/pgsql/src/backend/storage/lmgr/lmgr.c,v
retrieving revision 1.99
diff -c -r1.99 lmgr.c
*** src/backend/storage/lmgr/lmgr.c	1 Jan 2009 17:23:47 -0000	1.99
--- src/backend/storage/lmgr/lmgr.c	11 Jan 2009 11:50:51 -0000
***************
*** 477,485 ****
  
  		LockRelease(&tag, ShareLock, false);
  
! 		if (!TransactionIdIsInProgress(xid))
  			break;
- 		xid = SubTransGetParent(xid);
  	}
  }
  
--- 477,484 ----
  
  		LockRelease(&tag, ShareLock, false);
  
! 		if (TransactionIdDidAbort(xid) || TransactionIdDidCommit(xid))
  			break;
  	}
  }
  
